## gocr-0.41.tar.bz2

=== Makefile ===
#
#  type "make help" for help
#
# TODO: examples
#       add rpm to dist package, man page
#
# Changes:
# - be sure that configure is called after untgz, tar original file attributes
# - suggestion of Marcel Pol 6Dec2001:
#      make install DESTDIR=$RPM_BUILD_ROOT
#

prefix = /usr
#bindir = $(prefix)/bin
bindir = /usr${exec_prefix}/bin

SHELL = /bin/sh
# this does not work on SuSE 6.0, why? (autoconf 2.12 do not set /bin/sh ?)
#SHELL = bash #
INSTALL = /usr/bin/install -c
CC = gcc
CFLAGS = -g -O2
# following DEFs are not used, but I play with it for training
CPPFLAGS = 
DEFS = -DHAVE_CONFIG_H
includedir = ${prefix}/include
#
# -pedantic -ansi -Wall
LDFLAGS = -lm 
LIBS = -lnetpbm 

RANLIB = ranlib
AR = ar


# files for devel.tgz
FILES = \
 AUTHORS Makefile Makefile.in bin/ doc/ include/ examples/ man/ src/\
 BUGS README make.bat CREDITS READMEde.txt REMARK.txt\
 HISTORY REVIEW configure gpl.html INSTALL TODO configure.in\
 install-sh gocr.spec .cvsignore

# files for distribution
AFILES = $(FILES) lib/ frontend/ api/

DIRS = doc/ include/ man/ examples/ bin/ src/ lib/

# export all make-variables to submakes - said to be not working on IRIS

# default rule
default: all

.PHONY : src doc examples frontend help clean proper distclean dist tgz rpm

# example file generation takes lot of memory and time, do it explicitely
# by make examples
all:	src Makefile
	@echo " --- for help do: make help ---"
	@echo " --- for documentation do: make doc ---"
	@echo " --- for examples do: make examples ---"

include/config.h: include/config.h.in configure
	./configure

configure: configure.in
	autoconf

Makefile: Makefile.in configure
	./configure

src/Makefile: src/Makefile.in configure
	./configure

src/api/Makefile: src/api/Makefile.in configure
	./configure

src/api/Makefile.in:
	touch src/api/Makefile.in
	@echo " * * * Warning: API part missed * * *"

src:
	$(MAKE) -C src all

man:
	$(MAKE) -C man all

doc:
	$(MAKE) -C doc all

examples:
	$(MAKE) -C examples all

frontend:
	$(MAKE) -C frontend all

gocr.tar.Z: $(FILES)
	tar -cf - $(FILES) | compress -c >gocr.tar.Z

.PHONY : zip help database
zip:
	zip -k -q gocr.zip $(FILES)
	@ls -al gocr.zip

help:
	@printf "make            - compile all\n"
	@printf "make src        - build lib and gocr\n"
	@printf "make man        - build manual\n"
	@printf "make doc        - make documentation\n"
	@printf "make frontend   - build frontend\n"
	@printf "make examples   - create examples ./examples/\n"
	@printf "make database   - create database\n"
	@printf "make clean      - erase temporary files\n"
	@printf "make proper     - erase all created files\n"
	@printf "make install    - Really? Its development version!\n"
	@printf "make uninstall  - remove installed files from the system\n"

database:
	$(SHELL) bin/create_db

# you can override this variable by: make install DESTDIR=yourpath
DESTDIR=/usr
.PHONY : install uninstall test examples
install:
	$(MAKE) -C src install
	$(MAKE) -C man install
	$(MAKE) -C doc install
	$(MAKE) -C examples install
	# $(MAKE) -C frontend install

uninstall:
	$(MAKE) -C src uninstall
	$(MAKE) -C man uninstall
	$(MAKE) -C doc uninstall
	$(MAKE) -C examples uninstall
	# $(MAKE) -C frontend uninstall

.version: src/gocr.c
	sed \
	 -e '/version_string/!d' \
	 -e 's/[^0-9.]*\([0-9.]*\).*/\1/' \
	 -e q \
	 src/gocr.c > .version

dist: .version
	echo gocr-`cat .version` > .fname
	-rm -rf `cat .fname`
	mkdir `cat .fname`
	# create subdirs, because cp -r bin/gocr.tcl jocr => jocr/gocr.tcl
	(cd `cat .fname`; mkdir $(DIRS))
	cp -r -p -d $(AFILES) `cat .fname`
	$(MAKE) -C `cat .fname` proper
	# for Win, DOS and Mac no configure available, reset config.h
	cp `cat .fname`/include/config.h.in `cat .fname`/include/config.h
	touch `cat .fname`/configure   # Makefile will be updated
	tar chzf ../`cat .fname`.tar.gz `cat .fname`
	ls -l ../`cat .fname`.tar.gz
	-rm -rf `cat .fname` .fname


# the tgz-option is only for the author, to carry the sources home
tgz:
	mkdir jocr		# causes an error if exist
	# create subdirs, because cp -r bin/gocr.tcl jocr => jocr/gocr.tcl
	(cd jocr; mkdir $(DIRS))
	-cp -rup -d $(FILES) CVS jocr
	$(MAKE) -C jocr proper
	if test -d jocr/src/api; then echo "--- rm -r jocr/src/api ---"; fi
	-rm -rf jocr/src/api
	# -rm -rf jocr/CVS jocr/*/CVS jocr/*/*/CVS # CVS tree
	-rm -rf jocr/Makefile jocr/src/Makefile jocr/include/config.h
	tar chzf ../jocr.tgz jocr
	ls -l ../jocr.tgz
	-rm -rf jocr

# the rpm option is for the author, to create simple rpm packages
TRPM = $(HOME)/tmp_gocr_build
# only gocr?
#VERSION=$(shell sed -e '/version_string/!d' -e 's/[^0-9.]*\([0-9.]*\).*/\1/' -e q src/gocr.c)
rpm: .version
	echo "%_topdir $(TRPM)" > ~/.rpmmacros
	mkdir -p $(TRPM)/{SOURCES,SPECS,BUILD,RPMS,SRPMS}
	sed "s/version.*[0-9]\.[0-9]*/version $$(cat .version)/"\
	 gocr.spec >$(TRPM)/SPECS/gocr.spec
	cp ../gocr-$$(cat .version).tar.gz $(TRPM)/SOURCES
	#rpmbuild -ba --nobuild gocr.spec  # bin+src-rpm
	(cd $(TRPM)/SPECS; rpmbuild -bb gocr.spec)
	rpm -qil -p $(TRPM)/RPMS/i?86/gocr-$$(cat .version)-*.i?86.rpm

# PHONY = don't look at file clean, -rm = start rm and ignore errors
.PHONY : clean proper
clean:
	-rm -f config.cache config.status config.log
	-rm -f *.aux *.log *.dvi *.ps *.lj *~ gocr.ini out.txt
	-rm -f convert.cc convert convert.o	# remove v0.2.4 rests
	$(MAKE) -C src clean
	$(MAKE) -C doc clean
	$(MAKE) -C examples/ clean


distclean: proper

proper: clean
	$(MAKE) -C src/ proper
	$(MAKE) -C doc proper
	$(MAKE) -C examples/ proper
	-rm -f gocr bin/gocr libPgm2asc.* out??.bmp

=== man/Makefile ===
#
# Makefile for ./man path, used by configure
#

PROGRAM = gocr

mandir = ${prefix}/share/man

INSTALL=/usr/bin/install -c
DESTDIR=/usr

default: all

all:

# PHONY = don't look at file clean, -rm = start rm and ignore errors
.PHONY : clean proper install uninstall
install: all
	$(INSTALL) -d $(DESTDIR)$(mandir)/man1
	$(INSTALL) ../man/man1/$(PROGRAM).1 $(DESTDIR)$(mandir)/man1

uninstall:
	-rm -f $(DESTDIR)$(mandir)/man1/$(PROGRAM).1

clean:
	-rm -f *.o *~

proper: clean

=== src/Makefile ===
#
# Makefile for ./src path, used by configure
#

EXEEXT = 
PROGRAM = gocr$(EXEEXT)
PGMASCLIB = Pgm2asc
LIBPGMASCLIB = lib$(PGMASCLIB).a
INCLUDEFILES = gocr.h

LIBOBJS=pgm2asc.o \
	box.o \
	database.o \
	detect.o \
	barcode.o \
	lines.o \
	list.o \
	ocr0.o \
	ocr0n.o \
	ocr1.o \
	otsu.o \
	output.o \
	pixel.o \
	unicode.o \
	remove.o \
	pnm.o \
	pcx.o \
	job.o

# these two lines are for cross-compiling, not tested
#srcdir = .
#VPATH = .
bindir = ${exec_prefix}/bin
libdir = ${exec_prefix}/lib
includedir = ${prefix}/include

CC=gcc
RANLIB=ranlib
INSTALL=/usr/bin/install -c

DEFS=-DHAVE_CONFIG_H
CPPFLAGS=
# to see the config.h
CFLAGS=-g -O2 $(CPPFLAGS) -I../include $(DEFS)
LDFLAGS=-lm  -lnetpbm  -L.
DESTDIR=/usr

.c.o: $(INCLUDEFILES)
	$(CC) $(CFLAGS) -c -o $*.o $<

default: all

all: $(PROGRAM) $(LIBPGMASCLIB)

$(PROGRAM): $(LIBPGMASCLIB) gocr.o
	$(CC) -o $@ gocr.o $(LDFLAGS) ./lib$(PGMASCLIB).a
	if test -r $(PROGRAM); then cp $@ ../bin; fi

gocr.o: gocr.h Makefile

.c.h:

$(LIBPGMASCLIB): $(LIBOBJS)
	-rm -f $@
	$(AR) cru $@ $(LIBOBJS)
	$(RANLIB) $@

$(LIBOBJS): Makefile

# PHONY = don't look at file clean, -rm = start rm and ignore errors
.PHONY : clean proper install uninstall
install: all
	$(INSTALL) -d $(DESTDIR)$(bindir) $(DESTDIR)$(libdir) $(DESTDIR)$(includedir)
	$(INSTALL) ../bin/$(PROGRAM) $(DESTDIR)$(bindir)
	$(INSTALL) ../bin/gocr.tcl   $(DESTDIR)$(bindir)  # better X11/bin?
	$(INSTALL) $(LIBPGMASCLIB) $(DESTDIR)$(libdir)
	$(INSTALL) $(INCLUDEFILES) $(DESTDIR)$(includedir)

# directories are not removed
uninstall:
	-rm -f $(DESTDIR)$(bindir)/$(PROGRAM)
	-rm -f $(DESTDIR)$(bindir)/gocr.tcl
	-rm -f $(DESTDIR)$(libdir)/$(LIBPGMASCLIB)
	for X in $(INCLUDEFILES); do rm -f $(DESTDIR)$(includedir)/$$X; done

clean:
	-rm -f *.o *~

proper: clean
	-rm -f gocr libPgm2asc.a

=== debian/changelog ===
gocr (0.41-1) unstable; urgency=low

  * new upstream version
    Closes: #388217
  * fixed gnome-frontend (frontend/gnome/src/functions.c) string quoting
    (debian/patches/gnome-frontend-functions.c.patch_allow_spaces)
  * fixed gnome-frontend showing button
    (debian/patches/gnome-frontend-functions.c.patch_show_buttons)
  * applied debian/patches/gocr-0.41-pgm.patch from upstream
  * quoted dashes in gocr.1 man page
    Closes: #272590

 -- Cosimo Alfarano <kalfa@debian.org>  Thu,  9 Nov 2006 14:08:47 +0100

gocr (0.39-5) unstable; urgency=high

  * security fix for http://www.overflow.pl/adv/gocr.txt
    Closes: #305068
  * copied src/pnm.c from 0.40 and patched gocr.c
    according to upstream, it's the best way to backport the fix from 0.40

 -- Cosimo Alfarano <kalfa@debian.org>  Wed, 20 Apr 2005 00:12:48 +0200

gocr (0.39-4) unstable; urgency=low

  * recommends libjpeg-progs, bzip2, netpbm, transfig in control
    (see pnm.c for list of autoinvoked command)
    Closes: #272282

 -- Cosimo Alfarano <kalfa@debian.org>  Sun, 19 Sep 2004 23:07:05 +0200

gocr (0.39-3) unstable; urgency=low

  * apply patches by Nicolas Fran\347ois for gocr-gtk
    that fix a problem with opening file with spaces and opening two files
    Closes: #197827,#197814

 -- Cosimo Alfarano <kalfa@debian.org>  Mon, 26 Jul 2004 18:19:33 +0200

gocr (0.39-2) unstable; urgency=low

  * debian/control: added Suggests: gocr-doc to gocr 
    closes: Bug#254827

 -- Cosimo Alfarano <kalfa@debian.org>  Thu, 15 Jul 2004 00:47:52 +0200

gocr (0.39-1) unstable; urgency=low

  * New upstream release
    closes: Bug#244223

 -- Cosimo Alfarano <kalfa@debian.org>  Sat, 17 Apr 2004 15:19:09 +0200

gocr (0.38-4) unstable; urgency=low

  * fixes the previous entry, that was upload by mistake without updating it
    :( 
  * built against libnetpbm10 (Build-Depends updated)
    closes: Bug#211258

 -- Cosimo Alfarano <kalfa@debian.org>  Thu, 25 Mar 2004 22:27:14 +0100

gocr (0.38-3) unstable; urgency=low

  * libnetpbm10 

 -- Cosimo Alfarano <kalfa@debian.org>  Thu, 25 Mar 2004 21:44:35 +0100

gocr (0.38-2) unstable; urgency=low

  * removed tk8.4-dev from Build-Depends, thanks to Florent Rougon
    closes: Bug#227533
  * suggesting xsane to goct-tk, since it can scan a document from GUI

 -- Cosimo Alfarano <kalfa@debian.org>  Tue, 23 Mar 2004 11:02:54 +0100

gocr (0.38-1) unstable; urgency=low

  * New Upstream Release

 -- Cosimo Alfarano <kalfa@debian.org>  Wed, 24 Dec 2003 19:37:25 +0100

gocr (0.37-3) unstable; urgency=low

  * debian/rules: ignore errorcode of find if CVS dir and some other files are
    not found during clean target execution
    closes: Bug#199933

 -- Cosimo Alfarano <kalfa@debian.org>  Fri,  4 Jul 2003 16:06:26 +0200

gocr (0.37-2) unstable; urgency=low

  * added autoconf in Build-Depends
    closes: Bug#199756
  * binary-arch target now depends on install target. it was forgot in some
    way
    closes: Bug#191633

 -- Cosimo Alfarano <kalfa@debian.org>  Thu,  3 Jul 2003 21:16:34 +0200

gocr (0.37-1) unstable; urgency=low

  * reuploading the old debian 0.3.7-1 version with the real upstream version
    fixed. it's 0.37!
  * changed deps of gocr-tk to respect current sid's tk version.
    (closes: Bug#194794)

 -- Cosimo Alfarano <kalfa@debian.org>  Tue, 27 May 2003 15:19:14 +0200

gocr (0.3.7-1) unstable; urgency=low

  * New Upstream Version  (closes: #173595)
  * Installed new gocr man page from sources (closes: Bug#174182,Bug#151736)

 -- Cosimo Alfarano <kalfa@debian.org>  Fri, 27 Dec 2002 19:29:24 +0100

gocr (0.3.4-10) unstable; urgency=low

  * fixed some typos in debian/control (closes: #142504,#142735)

 -- Cosimo Alfarano <kalfa@debian.org>  Tue, 16 Apr 2002 14:07:04 +0200

gocr (0.3.4-9) unstable; urgency=low

  * fixed gtk-ocr segfault during setting (closes: Bug#136913) 
    modified line are tagged "//KA"

 -- Cosimo Alfarano <kalfa@debian.org>  Tue,  5 Mar 2002 16:47:56 +0100

gocr (0.3.4-8) unstable; urgency=low

  *  arch-dep and arch-indep packages splitted in debian/rules

 -- Cosimo Alfarano <kalfa@debian.org>  Fri, 22 Feb 2002 19:18:53 +0100

gocr (0.3.4-7) unstable; urgency=low

  * fixed a type in Description (closes: Bug#125619)
  * added gsfonts and tk8.0-dev to Build-Depends: (closes: Bug#126284)

 -- Cosimo Alfarano <kalfa@debian.org>  Sun, 23 Dec 2001 22:55:20 +0100

gocr (0.3.4-6) unstable; urgency=low

  * fixed section of gocr-doc in debian/control (from graphic to doc)
  * replaced gv with gs to Build-Depends: (closes: Bug#116882)

 -- Cosimo Alfarano <kalfa@debian.org>  Wed, 24 Oct 2001 21:40:22 +0000

gocr (0.3.4-5) unstable; urgency=low

  * Completly rewritten all Descriptions (closes: Bug#116796)
  * patching frontend/gnome/src/function.c In saving file.
    s/+1/+2/ allocing memory for filename $HOME/.gtk_ocr (closes: Bug#116670)

 -- Cosimo Alfarano <kalfa@debian.org>  Tue, 23 Oct 2001 22:38:30 +0000

gocr (0.3.4-4) unstable; urgency=low

  * patched frontend/gnome/src/functions.c (segfault)
  * removed all config.{status,cache} (debian/rules clean)
  * changed path to common-licenses in copyright file
  * patched exaple/Makefile clean targed (more file removed)

 -- Cosimo Alfarano <kalfa@debian.org>  Tue, 22 Oct 2001 21:35:43 +0000

gocr (0.3.4-3) unstable; urgency=low

  * controlled and fixed all Descriptions (closes: #101781)

 -- Cosimo Alfarano <kalfa@debian.org>  Fri, 19 Oct 2001 17:09:37 +0200

gocr (0.3.4-2) unstable; urgency=low

  * orig.tgz created.... debian release 1 missing it

 -- Cosimo Alfarano <kalfa@debian.org>  Fri, 19 Oct 2001 00:25:03 +0000

gocr (0.3.4-1) unstable; urgency=low

  * New upstream release
  * Patched examples/Makefile -> in target examples added text.ps font.ps
  * Patched frontend/Makefile -> in target all added $(MAKE) -C src all

 -- Cosimo Alfarano <kalfa@debian.org>  Thu, 18 Oct 2001 23:29:03 +0000

gocr (0.3.3-1) unstable; urgency=low

  * new upstream version (closes: #87979)


=== debian/control ===
Source: gocr
Section: graphics
Priority: optional
Maintainer: Cosimo Alfarano <kalfa@debian.org>
Standards-Version: 3.5.10
Build-Depends: tetex-bin, debhelper (>= 3.0), autoconf, libgtk1.2-dev, libnetpbm10-dev, netpbm, transfig, gs, gsfonts

Package: gocr
Architecture: any
Depends: ${shlibs:Depends}
Suggests: gocr-doc
Recommends: libjpeg-progs, bzip2, netpbm, transfig
Description: A command line OCR
 gocr is a multi-platform OCR (Optical Character Recognition) program.
 .
 It can read pnm, pbm, pgm, ppm, some pcx and tga image files.
 .
 Currently the program should be able to handle well scans that have their text
 in one column and do not have tables. Font sizes of 20 to 60
 pixels are supported.
 .
 If you want to write your own OCR, libgocr is provided in a separate
 package. Documentation and graphical wrapper are provided in separated
 packages, too.
     
Package: gocr-doc
Section: doc
Architecture: all
Description: gocr documentation
 gocr is a multi-platform OCR (Optical Character Recognition) program.
 .
 It can read pnm, pbm, pgm, ppm, some pcx and tga image files.
 .
 It is documentation about gocr and OCRs.

Package: gocr-tk
Architecture: any
Depends: gocr, tk8.4 | wish
Suggests: xsane
Description: A tcl/tk wrapper around gocr
 gocr is a multi-platform OCR (Optical Character Recognition) program.
 .
 It can read pnm, pbm, pgm, ppm, some pcx and tga image files.
 .
 It is a tlc/tk GUI to gocr (a command line program).
 
Package: gocr-gtk
Architecture: any
Depends: gocr, ${shlibs:Depends}
Description: A GTK wrapper around gocr
 gocr is a multi-platform OCR (Optical Character Recognition) program.
 .
 It can read pnm, pbm, pgm, ppm, some pcx and tga image files.
 .
 It is a GTK GUI to gocr (command line program).

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif


# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=3

# set any of this variable to TRUE to  install them, to FALSE to do not install
INSTALLDATABASE=FALSE

configure: configure-stamp
configure-stamp:
	dh_testdir

	./configure --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info
	( cd $(CURDIR)/frontend/gnome ; \
	./configure --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info ; ) 

	touch configure-stamp


build: build-stamp
build-stamp: configure-stamp
	
	if [ $(INSTALLDATABASE) = TRUE ]; \
	then \
		$(MAKE) database; \
	fi

	$(MAKE)
	$(MAKE) examples
	$(MAKE) doc

	( cd $(CURDIR)/frontend/gnome && ./configure )
	$(MAKE) frontend
	#$(MAKE) -C $(CURDIR)/frontend/gnome # I changed frontend/Makefile

	touch build-stamp


clean:
	dh_testdir
	rm -f build-stamp

	-$(MAKE) proper
	-$(MAKE) -C $(CURDIR)/frontend/gnome distclean
	
	# and some other debian/autoconf tmp file
	-find $(CURDIR) -name "*~" -exec rm -v {} \;
	-find $(CURDIR) -type f -name config.log -or \
		-name config.cache -or \
		-name config.status \
		-exec rm -v {} \;
	-find $(CURDIR) -type d \
		-name CVS \
		-exec rm -rfv {} \; 
	-rm -vrf debian/tmp debian/files* core debian/substvars

	dh_clean


install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/tmp.
#	$(MAKE) install exec_prefix=$(CURDIR)/debian/tmp/usr prefix=$(CURDIR)/debian/tmp/usr INSTALL=/usr/bin/install
	install -D $(CURDIR)/bin/gocr $(CURDIR)/debian/gocr/usr/bin/gocr
	install -D $(CURDIR)/bin/gocr.tcl $(CURDIR)/debian/gocr-tk/usr/bin/gocr.tcl
	install -D $(CURDIR)/frontend/gnome/src/gtk-ocr $(CURDIR)/debian/gocr-gtk/usr/bin/gtk-ocr

#	install -D $(CURDIR)/doc/*ps $(CURDIR)/doc/*dvi $(CURDIR)/doc/*txt $(CURDIR)/debian/gocr-doc/usr/share/doc/gocr/doc


# Build architecture-independent
binary-indep: build install
	dh_testdir 
	dh_testroot

	dh_installdocs -i
	dh_installexamples -i

	dh_installmenu -i
	dh_installman -i

	dh_installchangelogs -i

	dh_compress -i -Xusr/share/doc/gocr/examples/font21.pcx
	
	dh_fixperms -i
	# dh_fixperms doesn't fix subdir perms
#	find debian/gocr/usr/share/doc/$(package) -type d -exec chmod 0755 {} \;

	dh_makeshlibs -i
	dh_installdeb -i

	dh_shlibdeps -i
	dh_gencontrol -i

	dh_md5sums -i
	dh_builddeb -i



# Build architecture-dependent
binary-arch: build install
	dh_testdir 
	dh_testroot

	dh_installdebconf -a

	dh_installdocs -a
	dh_installexamples -a

	dh_installmenu -a
	dh_installman -a

	dh_installchangelogs -a

	dh_strip -a
	dh_compress -a -Xusr/share/doc/gocr/examples/font21.pcx
	
	dh_fixperms -a
	# dh_fixperms doesn't fix subdir perms
#	find debian/gocr/usr/share/doc/$(package) -type d -exec chmod 0755 {} \;

	dh_makeshlibs -a
	dh_installdeb -a

	dh_shlibdeps -a
	dh_gencontrol -a

	dh_md5sums -a
	dh_builddeb -a


binary: binary-indep binary-arch

.PHONY: build clean binary binary-indep binary-arch binary install configure
